#!/usr/bin/env ruby
require 'diaria/config'
require 'diaria/decoder'

require 'runit/testcase'
require 'yaml'
require 'date'

class Content
	attr_accessor :id, :title, :body, :date
	def initialize
		@body = ""
		@date = Time.new
	end
end

class YamlEncoder
	def YamlEncoder.encode_file( filename, object )
		out = File.new(filename,"w")
		out.write object.to_yaml
		out.close
	end
end


class TestBlog < RUNIT::TestCase

        def test_yaml_encoder
		c = Content.new
		c.id = 44
		c.title = "Everything about 44"
		c.body = <<EOS
		So you like baseball?
		Every watch Gladiator movies?
EOS
		c.date = Time.gm( 2003, 3, 12, 3, 47)
		c_yaml = c.to_yaml
		puts c_yaml
		new_c = YAML::load c_yaml
		
		assert_equals( c.id, new_c.id )
		assert_equals( c.title, new_c.title )
		assert_equals( c.body, new_c.body )
		assert_equals( c.date, new_c.date )
	end	
end

#Standalone driver
if $0 == __FILE__
  require 'runit/cui/testrunner'
  RUNIT::CUI::TestRunner.run(TestBlog.suite)
end
