#!/usr/bin/env ruby

#greymatter data parser

#format...
#entry_number	111
#user		ozten
#title			Hybrid Flex Car
#			|5
#month		|9
#day			|27
#year		|2002
#			|9
#			|28
#			|53
#			|AM
#			|0
#			|0
#			|0
#			|yes
#			|yes
#			|open
#\n
#			0.0.0.0
#			|I
#copy		We used one of the downtown Seattle <a href="http://www.flexcar.com/">Flex cars</a> and it was a Hybrid Honda Civic. What an awsome car! It was so quite! The dashboard was uberTron. I am not really into cars, but if I was going to buy one I would look at the cost of ownership and true environmental benefit for one of these guys. You don't have to plug it's batteries in at night.|*||*|I guess flexcar has a total of <a href="http://www.flexcar.com/company/pr/pr092502.asp">20 Hybrids</a>. Good for them.

class GMDecoder
	attr_accessor :content, :day, :month, :year, :hour, :minute, :second
	def GMDecoder.decode_file( filename )
		ls = Array.new
		File.open( filename )do|f|
			f.each do |line|
				ls.push( line )
			end
		end
		return GMDecoder.decode( ls )
	end
	def GMDecoder.decode( lines )
		#puts "Decoding"
		counter = 0
		decoder = GMDecoder.new
		decoder.content = Content.new
		lines.each() do |line|
			#puts "Doing #{line}"
			chunks = line.split('|') 
			chunks.each do | chunk |
				#puts "InnerDoing #{chunk}"
				decoder.loadData( chunk, counter )
				counter = counter + 1
			end
		end
		decoder.content.date = Time.gm( decoder.year, decoder.month, decoder.day, decoder.hour, decoder.minute, decoder.second )
		decoder.content
	end
	def loadData( data , slotNumber )		
		if( slotNumber == 0 )
			@content.id = data.to_i
		elsif( slotNumber == 2 )
			@content.title = data
		elsif( slotNumber == 4 )
			@month = data.to_i
		elsif( slotNumber == 5 )
			@day = data.to_i
		elsif( slotNumber == 6 )
			@year = data.to_i
		elsif( slotNumber == 7 )
			@hour = data.to_i
		elsif( slotNumber == 8 )
			@minute = data.to_i
		elsif( slotNumber == 9 )
			@second = data.to_i
		elsif( slotNumber >= 19 )
			@content.body << data
		else
			#puts "#{slotNumber} #{data}"
		end
		
	end
end

class TestGM < RUNIT::TestCase
	@data111
	@data6
	@data268
	def setup
		@data111 = Array.new
		@data111.push("111|ozten|Hybrid Flex Car|5|9|27|2002|9|28|53|AM|0|0|0|yes|yes|open")
		@data111.push("0.0.0.0|I")
		@data111.push("We used one of the downtown Seattle <a href=\"http://www.flexcar.com/\">Flex cars</a> and it was a Hybrid Honda Civic. What an awsome car! It was so quite! The dashboard was uberTron. I am not really into cars, but if I was going to buy one I would look at the cost of ownership and true environmental benefit for one of these guys. You don't have to plug it's batteries in at night.|*||*|I guess flexcar has a total of <a href=\"http://www.flexcar.com/company/pr/pr092502.asp\">20 Hybrids</a>. Good for them.")
		
		@data6 = Array.new
		@data6.push("6|ozten|Mozilla 1.0 Review|5|6|7|2002|9|21|48|AM|0|0|0|yes|yes|open")
		@data6.push("0.0.0.0|I")
		@data6.push("<a href=\"http://ozten.com/images/screenshot-1.jpg\" width=100 height=100 border=1 alt=\"screenshot\"><img src=\"http://ozten.com/images/thumb_screenshot-1.jpg\" alt=\"Screenshot of Mozilla 1.0\" width=\"100\" height=\"100\" border=\"0\" align=\"left\"></a>I   have upgraded to <a href=\"http://www.mozilla.org/releases/\">Mozilla 1.0</a>  on my windows box. <font size=\"-1\">(I am still running ancient 0.9.4 on my Mandrake  laptop)</font> and I must say wow. This release feels very stable! The tabbed  panes are awesome. Control T launches a new tab, as does middle clicking a link! Although Mozilla doesn't have all the little features of Opera, I prefer Moz,   because it has better use of screen real estate.")
		@data6.push("I am also using the mail client again which is nice. In earlier builds, my   mail client had become so busted that I started using mutt again.   I have been using the new Mozilla's mail client for last couple of days and things   are going very smoothly. Actually I have only noticed one minor bug with the |*|  whole package. The textfield widget of the browser location/address bar still wigs out   occasionally. If you close the offending tab, then it will start to respond   again.|*||*|This build is the most <a href=\"http://www.w3.org/\">W3C</a> standards compliant   yet! Most sites look great. Some poorly written JavaScript fails on say a MicroSoft   site like hotmail, but what do you want??? <a href=\"http://www.w3.org/Style/CSS/\">CSS</a>   and <a  ref=\"http://www.ecma.ch/ecma1/STAND/ECMA-262.HTM\">JavaScript</a> work   well with the specs. The JavaScript <a href=\"javascript:\">debugging console</a>   is still there which has been one of my favorite features always.|*||*|It is really nice to have free quality software that you can run on all your   computers. Thanks again to all the Mozilla hackers for creating such a great   piece of software. Thanks for keeping the version numbers realistic! Wow 1.0,   you have earned it.")

		@data268 = Array.new
		@data268.push("268|ozten|Bowling for CNN|3|4|16|2003|9|30|2|AM|0|0|0|yes|yes|open")
		@data268.push("0.0.0.0|I")
		@data268.push("<a href=\"http://www.lisarein.com/michaelmoore/michaelmoorecompare.html\">Proof</a> that CNN is a war mongering \"news channel\". CNN altered the Oscar footage of Michael Moore's Speech to increase the volume of boos from the crowd.|*||*|Speaking of the oscar winning <a href=\"http://us.imdb.com/Title?0310793\">Bowling for Columbine</a> we went and saw it last night. My usual cavets with Moore's obtuse and overly explained messages. Put those points aside ( he is maturing on his interview technique ) this movie is incredible!!! The animation sequence explaining how fear is the driving force of White history is a very interesting filter to apply! Genius.|*||*|Moore did a great job of digging into US Political history showing Sudan, Taliban, and Twin Towers. The links are there but very few people are talking about it, and none except Moore have penetrated the mainstream.|*||*|There are great interviews such as the Marilon Manson and Matt Stone segments. This film should be shown in every high school civics class.")
	end
	def test_gm_decode
		content = GMDecoder.decode( @data111 )
		assert_equal("Hybrid Flex Car", content.title )
		assert_equal(111, content.id)
		#assert_equal(Time.gm(2002,9,27,9,28), content.date)
				
		content = GMDecoder.decode( @data6 )
		assert_equal("Mozilla 1.0 Review", content.title )
		assert_equal(6, content.id)
		
		content = GMDecoder.decode( @data268 )
		assert_equal("Bowling for CNN", content.title)
		assert_equal(268, content.id)
		#assert_equal(Time.gm(2003, 4, 16), content.date)

	end
	def test_gm_decode_file
		c = GMDecoder.decode_file("data/00000324.cgi")
		assert_equal(324, c.id)
		#puts "#{c.to_yaml}"
	end
end
#Standalone driver
if $0 == __FILE__
  require 'runit/cui/testrunner'
  RUNIT::CUI::TestRunner.run(TestGM.suite)
end