#!/usr/bin/env ruby
require "tempfile"

class UserInput
	def UserInput.fill( label="Type stuff, then press enter:" )
		body = ""
		editor_worked = false
		
		tf = Tempfile.new("diaria")
		filepath = tf.path.to_s
		tf.close
		t = Thread.new do
			shell_out = system( UserInput.resolve_editor(),filepath)
			if( shell_out )
				editor_worked = true
			end
		end
		t.join
		
		if( editor_worked )		
			File.open(filepath) do |f|
				f.each_line do |line|
					body << line
				end
			end
		else
			puts label
			body << gets
		end
		body
	end
	
	def UserInput.resolve_editor()
		rv = "no_editor"
		if( ENV["EDITOR"] != nil )
			rv = ENV["EDITOR"]
		else
			if( RUBY_PLATFORM =~ /win32/ )
			    if $debug
				puts "Your EDITOR env variable wasn't set, using notepad.exe"
			    end
				rv = "Notepad.exe"
			else
			    if
				puts "Your EDITOR env variable wansn't set, using vi"
			    end
				rv = "vi"
			end
		end
		return rv
	end
end

require 'runit/testcase'
class TestUserInput < RUNIT::TestCase
    def test_fill_body
    	body = ""
	puts "Please type FooBarBaz when asked"
	#puts ENV["EDITOR"].methods
	
	if( ENV.has_key?("EDITOR") )
		puts "Using #{ENV["EDITOR"]}"
	else
		ENV["EDITOR"] = "C:/Program Files/TextPad 4/TextPad.exe"
		puts "Setting EDITOR to #{ENV["EDITOR"]}"
	end
	UserInput.fill_body( body ,"Body:")
	puts "outside of method #{body}"
	assert_equals( "FooBarBaz", body )
    end
end

#Standalone driver
if $0 == __FILE__
  require 'runit/cui/testrunner'
  RUNIT::CUI::TestRunner.run(TestUserInput.suite)
end
