require 'diaria/blog'
require 'diaria/config'
require 'yaml'
# blog html around title link body and date used in index.html and each archived page
blog_post_pre_title = "<div class=\"copy\"><h2>\n"
blog_post_title_pre_link = "<sup><a HREF=\""
blog_post_link_pre_body = "\">#</a></sup></h2>\n"
blog_post_body_pre_date = "<p ALIGN=LEFT class=\"date\">\n"
blog_post_post_date = "</p>\n</div>\n\n"

# rss markup around title link and body
rss_date = Time.now.strftime("%a, %d %b %Y %H:%M:%S GMT") #Sunday, 13 Jul 2003 10:45:37 GMT
#$conf = Config.new
#TODO -- make rss_header a template file
rss_header = ""
File.open("#{$conf.template_dir}/rss.xml","r") do | file |
	file.readlines.each do | line |
		line.sub!(/\#\{rss_date\}/,"#{rss_date}")
		rss_header << line		
	end
end
rss_pre_title = "<item><title>"
rss_post_title = "</title><description>"
rss_post_body = "</description><link>"
rss_post_link = "</link></item>"
rss_footer = "</channel></rss>"
if $debug
    puts "template dir is #{$conf.template_dir}"
end
header = ""
File.open("#{$conf.template_dir}/header.html","r") do | file |
	file.readlines.each do | line |
		header << line		
	end
end
footer = ""
File.open("#{$conf.template_dir}/footer.html","r") do |file|
	file.readlines.each do | line |
		footer << line
	end
end
#puts footer
if $debug
    puts "Using data from #{$conf.data_dir}"
end
dir = Dir.open( $conf.data_dir ) 
blog_posts = Array.new
dir.each do | file |
	if( file =~ /[0-9]*\.blog/ )
		puts "adding #{file}"
		blog_posts.push file
	else
		puts "#{file} is not recognized"
	end
end
blog_posts.sort!{|a,b|
  rv = 0
  if( a.to_i() > b.to_i() )
    rv = 1
  elsif( a.to_i() < b.to_i() )
    rv = -1
  end
  rv
}
blog_posts.each{|x| print x, "\n"}
if blog_posts.length >= 7
	current = blog_posts.slice( blog_posts.length - 7, 7)
else
	current = blog_posts
end

#current = blog_posts
current.reverse!
puts current
index = File.new("#{$conf.html_dir}/index.html","w")
index.write header

rss = File.new("#{$conf.html_dir}/#{$conf.rss_filename}","w")
rss.write rss_header
current.each() do | b | 
	entry = YAML::load( File.new("#{$conf.data_dir}/#{b}").readlines.to_s )
	if entry.title == nil
		entry.title = ""
	end
	if entry.body == nil
		entry.body = ""
	end
	#puts "#{entry.id}\n#{entry.title}\n#{entry.body}\n"
	puts "Opening #{$conf.html_dir}/#{entry.id}.html"
	out = File.new("#{$conf.html_dir}/#{entry.id}.html","w")
	out.write header
	out.write "\n\n"
	out.write blog_post_pre_title
	out.write entry.title
	out.write blog_post_title_pre_link
	out.write "#{$conf.archive_link_prefix}#{entry.id}.html"	
	out.write blog_post_link_pre_body
	out.write entry.body
	out.write blog_post_body_pre_date
	out.write entry.date.strftime("%a, %d %b %Y %H:%M:%S GMT")
	out.write blog_post_post_date
	out.close
	
	index.write "\n\n"
	index.write blog_post_pre_title
	index.write entry.title
	index.write blog_post_title_pre_link
	index.write "#{$conf.archive_link_prefix}#{entry.id}.html"	
	index.write blog_post_link_pre_body
	index.write entry.body
	index.write blog_post_body_pre_date
	index.write entry.date.strftime("%a, %d %b %Y %H:%M:%S GMT")
	index.write blog_post_post_date
	
	rss.write "\n\n"
	rss.write rss_pre_title
	rss.write entry.title.gsub(/&/, "&amp;").gsub(/</, "&lt;").gsub(/>/,"&gt;").gsub(/\"/,"&quot;")
	rss.write rss_post_title
	rss.write entry.body.gsub(/&/, "&amp;").gsub(/</, "&lt;").gsub(/>/,"&gt;").gsub(/\"/,"&quot;")
	rss.write rss_post_body
	rss.write "#{$conf.archive_link_prefix}#{entry.id}.html"	
	rss.write rss_post_link
end

index.write footer
rss.write rss_footer
